commit cbd84e711c1e40e3517492fe2603bd652e38e68c
Author: Gao,Yan <ygao@suse.com>
Date:   Thu Feb 20 02:00:42 2014 +0800

    Test: pengine: cl#5187 - Prevent resources in an anti-colocation from even temporarily running on a same node

diff --git a/pengine/regression.sh b/pengine/regression.sh
index 59cf7c3..7c3b55b 100755
--- a/pengine/regression.sh
+++ b/pengine/regression.sh
@@ -162,6 +162,7 @@ do_test coloc-clone-stays-active "Ensure clones don't get stopped/demoted becaus
 do_test coloc_fp_logic "Verify floating point calculations in colocation are working"
 do_test colo_master_w_native "cl#5070 - Verify promotion order is affected when colocating master to native rsc."
 do_test colo_slave_w_native  "cl#5070 - Verify promotion order is affected when colocating slave to native rsc."
+do_test anti-colocation-order "cl#5187 - Prevent resources in an anti-colocation from even temporarily running on a same node"
 
 echo ""
 do_test rsc-sets-seq-true "Resource Sets - sequential=false"
diff --git a/pengine/test10/anti-colocation-order.dot b/pengine/test10/anti-colocation-order.dot
new file mode 100644
index 0000000..332d2b0
--- /dev/null
+++ b/pengine/test10/anti-colocation-order.dot
@@ -0,0 +1,43 @@
+digraph "g" {
+"all_stopped" [ style=bold color="green" fontcolor="orange"]
+"group1_running_0" [ style=bold color="green" fontcolor="orange"]
+"group1_start_0" -> "group1_running_0" [ style = bold]
+"group1_start_0" -> "rsc1_start_0 node2" [ style = bold]
+"group1_start_0" -> "rsc2_start_0 node2" [ style = bold]
+"group1_start_0" [ style=bold color="green" fontcolor="orange"]
+"group1_stop_0" -> "group1_stopped_0" [ style = bold]
+"group1_stop_0" -> "rsc1_stop_0 node1" [ style = bold]
+"group1_stop_0" -> "rsc2_stop_0 node1" [ style = bold]
+"group1_stop_0" [ style=bold color="green" fontcolor="orange"]
+"group1_stopped_0" -> "group1_start_0" [ style = bold]
+"group1_stopped_0" [ style=bold color="green" fontcolor="orange"]
+"group2_stop_0" -> "group2_stopped_0" [ style = bold]
+"group2_stop_0" -> "rsc3_stop_0 node2" [ style = bold]
+"group2_stop_0" -> "rsc4_stop_0 node2" [ style = bold]
+"group2_stop_0" [ style=bold color="green" fontcolor="orange"]
+"group2_stopped_0" -> "group1_start_0" [ style = bold]
+"group2_stopped_0" [ style=bold color="green" fontcolor="orange"]
+"probe_complete node1" [ style=bold color="green" fontcolor="black"]
+"probe_complete node2" [ style=bold color="green" fontcolor="black"]
+"rsc1_start_0 node2" -> "group1_running_0" [ style = bold]
+"rsc1_start_0 node2" -> "rsc2_start_0 node2" [ style = bold]
+"rsc1_start_0 node2" [ style=bold color="green" fontcolor="black"]
+"rsc1_stop_0 node1" -> "all_stopped" [ style = bold]
+"rsc1_stop_0 node1" -> "group1_stopped_0" [ style = bold]
+"rsc1_stop_0 node1" -> "rsc1_start_0 node2" [ style = bold]
+"rsc1_stop_0 node1" [ style=bold color="green" fontcolor="black"]
+"rsc2_start_0 node2" -> "group1_running_0" [ style = bold]
+"rsc2_start_0 node2" [ style=bold color="green" fontcolor="black"]
+"rsc2_stop_0 node1" -> "all_stopped" [ style = bold]
+"rsc2_stop_0 node1" -> "group1_stopped_0" [ style = bold]
+"rsc2_stop_0 node1" -> "rsc1_stop_0 node1" [ style = bold]
+"rsc2_stop_0 node1" -> "rsc2_start_0 node2" [ style = bold]
+"rsc2_stop_0 node1" [ style=bold color="green" fontcolor="black"]
+"rsc3_stop_0 node2" -> "all_stopped" [ style = bold]
+"rsc3_stop_0 node2" -> "group2_stopped_0" [ style = bold]
+"rsc3_stop_0 node2" [ style=bold color="green" fontcolor="black"]
+"rsc4_stop_0 node2" -> "all_stopped" [ style = bold]
+"rsc4_stop_0 node2" -> "group2_stopped_0" [ style = bold]
+"rsc4_stop_0 node2" -> "rsc3_stop_0 node2" [ style = bold]
+"rsc4_stop_0 node2" [ style=bold color="green" fontcolor="black"]
+}
diff --git a/pengine/test10/anti-colocation-order.exp b/pengine/test10/anti-colocation-order.exp
new file mode 100644
index 0000000..19d6def
--- /dev/null
+++ b/pengine/test10/anti-colocation-order.exp
@@ -0,0 +1,217 @@
+<transition_graph cluster-delay="60s" stonith-timeout="60s" failed-stop-offset="INFINITY" failed-start-offset="INFINITY"  transition_id="0">
+  <synapse id="0" priority="100">
+    <action_set>
+      <pseudo_event id="12" operation="stopped" operation_key="group1_stopped_0">
+        <attributes CRM_meta_timeout="20000" />
+      </pseudo_event>
+    </action_set>
+    <inputs>
+      <trigger>
+        <rsc_op id="5" operation="stop" operation_key="rsc1_stop_0" on_node="node1" on_node_uuid="node1"/>
+      </trigger>
+      <trigger>
+        <rsc_op id="7" operation="stop" operation_key="rsc2_stop_0" on_node="node1" on_node_uuid="node1"/>
+      </trigger>
+      <trigger>
+        <pseudo_event id="11" operation="stop" operation_key="group1_stop_0"/>
+      </trigger>
+    </inputs>
+  </synapse>
+  <synapse id="1" priority="100">
+    <action_set>
+      <pseudo_event id="11" operation="stop" operation_key="group1_stop_0">
+        <attributes CRM_meta_timeout="20000" />
+      </pseudo_event>
+    </action_set>
+    <inputs/>
+  </synapse>
+  <synapse id="2" priority="100">
+    <action_set>
+      <pseudo_event id="10" operation="running" operation_key="group1_running_0">
+        <attributes CRM_meta_timeout="20000" />
+      </pseudo_event>
+    </action_set>
+    <inputs>
+      <trigger>
+        <rsc_op id="6" operation="start" operation_key="rsc1_start_0" on_node="node2" on_node_uuid="node2"/>
+      </trigger>
+      <trigger>
+        <rsc_op id="8" operation="start" operation_key="rsc2_start_0" on_node="node2" on_node_uuid="node2"/>
+      </trigger>
+      <trigger>
+        <pseudo_event id="9" operation="start" operation_key="group1_start_0"/>
+      </trigger>
+    </inputs>
+  </synapse>
+  <synapse id="3" priority="100">
+    <action_set>
+      <pseudo_event id="9" operation="start" operation_key="group1_start_0">
+        <attributes CRM_meta_timeout="20000" />
+      </pseudo_event>
+    </action_set>
+    <inputs>
+      <trigger>
+        <pseudo_event id="12" operation="stopped" operation_key="group1_stopped_0"/>
+      </trigger>
+      <trigger>
+        <pseudo_event id="18" operation="stopped" operation_key="group2_stopped_0"/>
+      </trigger>
+    </inputs>
+  </synapse>
+  <synapse id="4" priority="100">
+    <action_set>
+      <rsc_op id="6" operation="start" operation_key="rsc1_start_0" on_node="node2" on_node_uuid="node2">
+        <primitive id="rsc1" class="ocf" provider="pacemaker" type="Dummy"/>
+        <attributes CRM_meta_timeout="20000" />
+      </rsc_op>
+    </action_set>
+    <inputs>
+      <trigger>
+        <rsc_op id="5" operation="stop" operation_key="rsc1_stop_0" on_node="node1" on_node_uuid="node1"/>
+      </trigger>
+      <trigger>
+        <pseudo_event id="9" operation="start" operation_key="group1_start_0"/>
+      </trigger>
+    </inputs>
+  </synapse>
+  <synapse id="5" priority="100">
+    <action_set>
+      <rsc_op id="5" operation="stop" operation_key="rsc1_stop_0" on_node="node1" on_node_uuid="node1">
+        <primitive id="rsc1" class="ocf" provider="pacemaker" type="Dummy"/>
+        <attributes CRM_meta_timeout="20000" />
+      </rsc_op>
+    </action_set>
+    <inputs>
+      <trigger>
+        <rsc_op id="7" operation="stop" operation_key="rsc2_stop_0" on_node="node1" on_node_uuid="node1"/>
+      </trigger>
+      <trigger>
+        <pseudo_event id="11" operation="stop" operation_key="group1_stop_0"/>
+      </trigger>
+    </inputs>
+  </synapse>
+  <synapse id="6" priority="100">
+    <action_set>
+      <rsc_op id="8" operation="start" operation_key="rsc2_start_0" on_node="node2" on_node_uuid="node2">
+        <primitive id="rsc2" class="ocf" provider="pacemaker" type="Dummy"/>
+        <attributes CRM_meta_timeout="20000" />
+      </rsc_op>
+    </action_set>
+    <inputs>
+      <trigger>
+        <rsc_op id="6" operation="start" operation_key="rsc1_start_0" on_node="node2" on_node_uuid="node2"/>
+      </trigger>
+      <trigger>
+        <rsc_op id="7" operation="stop" operation_key="rsc2_stop_0" on_node="node1" on_node_uuid="node1"/>
+      </trigger>
+      <trigger>
+        <pseudo_event id="9" operation="start" operation_key="group1_start_0"/>
+      </trigger>
+    </inputs>
+  </synapse>
+  <synapse id="7" priority="100">
+    <action_set>
+      <rsc_op id="7" operation="stop" operation_key="rsc2_stop_0" on_node="node1" on_node_uuid="node1">
+        <primitive id="rsc2" class="ocf" provider="pacemaker" type="Dummy"/>
+        <attributes CRM_meta_timeout="20000" />
+      </rsc_op>
+    </action_set>
+    <inputs>
+      <trigger>
+        <pseudo_event id="11" operation="stop" operation_key="group1_stop_0"/>
+      </trigger>
+    </inputs>
+  </synapse>
+  <synapse id="8" priority="10">
+    <action_set>
+      <pseudo_event id="18" operation="stopped" operation_key="group2_stopped_0">
+        <attributes CRM_meta_timeout="20000" />
+      </pseudo_event>
+    </action_set>
+    <inputs>
+      <trigger>
+        <rsc_op id="13" operation="stop" operation_key="rsc3_stop_0" on_node="node2" on_node_uuid="node2"/>
+      </trigger>
+      <trigger>
+        <rsc_op id="14" operation="stop" operation_key="rsc4_stop_0" on_node="node2" on_node_uuid="node2"/>
+      </trigger>
+      <trigger>
+        <pseudo_event id="17" operation="stop" operation_key="group2_stop_0"/>
+      </trigger>
+    </inputs>
+  </synapse>
+  <synapse id="9" priority="10">
+    <action_set>
+      <pseudo_event id="17" operation="stop" operation_key="group2_stop_0">
+        <attributes CRM_meta_timeout="20000" />
+      </pseudo_event>
+    </action_set>
+    <inputs/>
+  </synapse>
+  <synapse id="10" priority="10">
+    <action_set>
+      <rsc_op id="13" operation="stop" operation_key="rsc3_stop_0" on_node="node2" on_node_uuid="node2">
+        <primitive id="rsc3" class="ocf" provider="pacemaker" type="Dummy"/>
+        <attributes CRM_meta_timeout="20000" />
+      </rsc_op>
+    </action_set>
+    <inputs>
+      <trigger>
+        <rsc_op id="14" operation="stop" operation_key="rsc4_stop_0" on_node="node2" on_node_uuid="node2"/>
+      </trigger>
+      <trigger>
+        <pseudo_event id="17" operation="stop" operation_key="group2_stop_0"/>
+      </trigger>
+    </inputs>
+  </synapse>
+  <synapse id="11" priority="10">
+    <action_set>
+      <rsc_op id="14" operation="stop" operation_key="rsc4_stop_0" on_node="node2" on_node_uuid="node2">
+        <primitive id="rsc4" class="ocf" provider="pacemaker" type="Dummy"/>
+        <attributes CRM_meta_timeout="20000" />
+      </rsc_op>
+    </action_set>
+    <inputs>
+      <trigger>
+        <pseudo_event id="17" operation="stop" operation_key="group2_stop_0"/>
+      </trigger>
+    </inputs>
+  </synapse>
+  <synapse id="12" priority="1000000">
+    <action_set>
+      <rsc_op id="4" operation="probe_complete" operation_key="probe_complete" on_node="node2" on_node_uuid="node2">
+        <attributes CRM_meta_op_no_wait="true" />
+      </rsc_op>
+    </action_set>
+    <inputs/>
+  </synapse>
+  <synapse id="13" priority="1000000">
+    <action_set>
+      <rsc_op id="3" operation="probe_complete" operation_key="probe_complete" on_node="node1" on_node_uuid="node1">
+        <attributes CRM_meta_op_no_wait="true" />
+      </rsc_op>
+    </action_set>
+    <inputs/>
+  </synapse>
+  <synapse id="14">
+    <action_set>
+      <pseudo_event id="1" operation="all_stopped" operation_key="all_stopped">
+        <attributes />
+      </pseudo_event>
+    </action_set>
+    <inputs>
+      <trigger>
+        <rsc_op id="5" operation="stop" operation_key="rsc1_stop_0" on_node="node1" on_node_uuid="node1"/>
+      </trigger>
+      <trigger>
+        <rsc_op id="7" operation="stop" operation_key="rsc2_stop_0" on_node="node1" on_node_uuid="node1"/>
+      </trigger>
+      <trigger>
+        <rsc_op id="13" operation="stop" operation_key="rsc3_stop_0" on_node="node2" on_node_uuid="node2"/>
+      </trigger>
+      <trigger>
+        <rsc_op id="14" operation="stop" operation_key="rsc4_stop_0" on_node="node2" on_node_uuid="node2"/>
+      </trigger>
+    </inputs>
+  </synapse>
+</transition_graph>
diff --git a/pengine/test10/anti-colocation-order.scores b/pengine/test10/anti-colocation-order.scores
new file mode 100644
index 0000000..07dc309
--- /dev/null
+++ b/pengine/test10/anti-colocation-order.scores
@@ -0,0 +1,21 @@
+Allocation scores:
+group_color: group1 allocation score on node1: 0
+group_color: group1 allocation score on node2: 0
+group_color: group2 allocation score on node1: 0
+group_color: group2 allocation score on node2: 0
+group_color: rsc1 allocation score on node1: 0
+group_color: rsc1 allocation score on node2: 0
+group_color: rsc2 allocation score on node1: 0
+group_color: rsc2 allocation score on node2: 0
+group_color: rsc3 allocation score on node1: 0
+group_color: rsc3 allocation score on node2: 0
+group_color: rsc4 allocation score on node1: 0
+group_color: rsc4 allocation score on node2: 0
+native_color: rsc1 allocation score on node1: -INFINITY
+native_color: rsc1 allocation score on node2: 0
+native_color: rsc2 allocation score on node1: -INFINITY
+native_color: rsc2 allocation score on node2: 0
+native_color: rsc3 allocation score on node1: 0
+native_color: rsc3 allocation score on node2: -INFINITY
+native_color: rsc4 allocation score on node1: -INFINITY
+native_color: rsc4 allocation score on node2: -INFINITY
diff --git a/pengine/test10/anti-colocation-order.summary b/pengine/test10/anti-colocation-order.summary
new file mode 100644
index 0000000..2447501
--- /dev/null
+++ b/pengine/test10/anti-colocation-order.summary
@@ -0,0 +1,44 @@
+
+Current cluster status:
+Node node1: standby
+Online: [ node2 ]
+
+ Resource Group: group1
+     rsc1	(ocf::pacemaker:Dummy):	Started node1 
+     rsc2	(ocf::pacemaker:Dummy):	Started node1 
+ Resource Group: group2
+     rsc3	(ocf::pacemaker:Dummy):	Started node2 
+     rsc4	(ocf::pacemaker:Dummy):	Started node2 
+
+Transition Summary:
+ * Move    rsc1	(Started node1 -> node2)
+ * Move    rsc2	(Started node1 -> node2)
+ * Stop    rsc3	(node2)
+ * Stop    rsc4	(node2)
+
+Executing cluster transition:
+ * Pseudo action:   group1_stop_0
+ * Resource action: rsc2            stop on node1
+ * Pseudo action:   group2_stop_0
+ * Resource action: rsc4            stop on node2
+ * Resource action: rsc1            stop on node1
+ * Resource action: rsc3            stop on node2
+ * Pseudo action:   all_stopped
+ * Pseudo action:   group1_stopped_0
+ * Pseudo action:   group2_stopped_0
+ * Pseudo action:   group1_start_0
+ * Resource action: rsc1            start on node2
+ * Resource action: rsc2            start on node2
+ * Pseudo action:   group1_running_0
+
+Revised cluster status:
+Node node1: standby
+Online: [ node2 ]
+
+ Resource Group: group1
+     rsc1	(ocf::pacemaker:Dummy):	Started node2 
+     rsc2	(ocf::pacemaker:Dummy):	Started node2 
+ Resource Group: group2
+     rsc3	(ocf::pacemaker:Dummy):	Stopped 
+     rsc4	(ocf::pacemaker:Dummy):	Stopped 
+
diff --git a/pengine/test10/anti-colocation-order.xml b/pengine/test10/anti-colocation-order.xml
new file mode 100644
index 0000000..7e58c24
--- /dev/null
+++ b/pengine/test10/anti-colocation-order.xml
@@ -0,0 +1,79 @@
+<cib epoch="1" num_updates="32" admin_epoch="0" validate-with="pacemaker-1.1" cib-last-written="Fri Jul 13 13:51:16 2012" have-quorum="1">
+  <configuration>
+    <crm_config>
+      <cluster_property_set id="cib-bootstrap-options">
+        <nvpair id="cib-bootstrap-options-stonith-enabled" name="stonith-enabled" value="false"/>
+        <nvpair id="cib-bootstrap-options-no-quorum-policy" name="no-quorum-policy" value="ignore"/>
+      </cluster_property_set>
+    </crm_config>
+    <nodes>
+      <node id="node1" type="normal" uname="node1">
+        <instance_attributes id="nodes-node1">
+          <nvpair id="nodes-node1-standby" name="standby" value="on"/>
+        </instance_attributes>
+      </node>
+      <node id="node2" type="normal" uname="node2">
+        <instance_attributes id="nodes-node2">
+          <nvpair id="nodes-node2-standby" name="standby" value="off"/>
+        </instance_attributes>
+      </node>
+    </nodes>
+    <resources>
+      <group id="group1">
+        <meta_attributes id="meta_1">
+          <nvpair id="meta_1_priority" name="priority" value="100"/>
+        </meta_attributes>
+        <primitive id="rsc1" class="ocf" provider="pacemaker" type="Dummy"/>
+        <primitive id="rsc2" class="ocf" provider="pacemaker" type="Dummy"/>
+      </group>
+      <group id="group2">
+        <meta_attributes id="meta_2">
+          <nvpair id="meta_2_priority" name="priority" value="10"/>
+        </meta_attributes>
+        <primitive id="rsc3" class="ocf" provider="pacemaker" type="Dummy"/>
+        <primitive id="rsc4" class="ocf" provider="pacemaker" type="Dummy"/>
+      </group>
+    </resources>
+    <constraints>
+      <rsc_colocation id="colo-1" rsc="group2" with-rsc="group1" score="-INFINITY"/>
+    </constraints>
+  </configuration>
+  <status>
+    <node_state id="node1" uname="node1" ha="active" in_ccm="true" crmd="online" join="member" expected="member" crm-debug-origin="crm_simulate">
+      <lrm id="node1">
+        <lrm_resources>
+          <lrm_resource id="rsc1" class="ocf" provider="pacemaker" type="Dummy">
+            <lrm_rsc_op id="rsc1_last_0" operation_key="rsc1_start_0" operation="start" crm-debug-origin="crm_simulate" crm_feature_set="3.0.8" transition-key="2:-1:0:xxxxxxxx-xxxx-xxxx-xxxx-xxxxxxxxxxxx" transition-magic="0:0;2:-1:0:xxxxxxxx-xxxx-xxxx-xxxx-xxxxxxxxxxxx" call-id="2" rc-code="0" op-status="0" interval="0" last-run="1387546150" last-rc-change="1387546150" exec-time="0" queue-time="0" op-digest="f2317cad3d54cec5d7d7aa7d0bf35cf8"/>
+          </lrm_resource>
+          <lrm_resource id="rsc2" class="ocf" provider="pacemaker" type="Dummy">
+            <lrm_rsc_op id="rsc2_last_0" operation_key="rsc2_start_0" operation="start" crm-debug-origin="crm_simulate" crm_feature_set="3.0.8" transition-key="2:-1:0:xxxxxxxx-xxxx-xxxx-xxxx-xxxxxxxxxxxx" transition-magic="0:0;2:-1:0:xxxxxxxx-xxxx-xxxx-xxxx-xxxxxxxxxxxx" call-id="2" rc-code="0" op-status="0" interval="0" last-run="1387546150" last-rc-change="1387546150" exec-time="0" queue-time="0" op-digest="f2317cad3d54cec5d7d7aa7d0bf35cf8"/>
+          </lrm_resource>
+          <lrm_resource id="rsc3" class="ocf" provider="pacemaker" type="Dummy">
+            <lrm_rsc_op id="rsc3_last_0" operation_key="rsc3_monitor_0" operation="monitor" crm-debug-origin="crm_simulate" crm_feature_set="3.0.8" transition-key="1:-1:7:xxxxxxxx-xxxx-xxxx-xxxx-xxxxxxxxxxxx" transition-magic="0:7;1:-1:7:xxxxxxxx-xxxx-xxxx-xxxx-xxxxxxxxxxxx" call-id="1" rc-code="7" op-status="0" interval="0" last-run="1387546150" last-rc-change="1387546150" exec-time="0" queue-time="0" op-digest="f2317cad3d54cec5d7d7aa7d0bf35cf8"/>
+          </lrm_resource>
+          <lrm_resource id="rsc4" class="ocf" provider="pacemaker" type="Dummy">
+            <lrm_rsc_op id="rsc4_last_0" operation_key="rsc4_monitor_0" operation="monitor" crm-debug-origin="crm_simulate" crm_feature_set="3.0.8" transition-key="1:-1:7:xxxxxxxx-xxxx-xxxx-xxxx-xxxxxxxxxxxx" transition-magic="0:7;1:-1:7:xxxxxxxx-xxxx-xxxx-xxxx-xxxxxxxxxxxx" call-id="1" rc-code="7" op-status="0" interval="0" last-run="1387546150" last-rc-change="1387546150" exec-time="0" queue-time="0" op-digest="f2317cad3d54cec5d7d7aa7d0bf35cf8"/>
+          </lrm_resource>
+        </lrm_resources>
+      </lrm>
+    </node_state>
+    <node_state id="node2" uname="node2" ha="active" in_ccm="true" crmd="online" join="member" expected="member" crm-debug-origin="crm_simulate">
+      <lrm id="node2">
+        <lrm_resources>
+          <lrm_resource id="rsc1" class="ocf" provider="pacemaker" type="Dummy">
+            <lrm_rsc_op id="rsc1_last_0" operation_key="rsc1_monitor_0" operation="monitor" crm-debug-origin="crm_simulate" crm_feature_set="3.0.8" transition-key="1:-1:7:xxxxxxxx-xxxx-xxxx-xxxx-xxxxxxxxxxxx" transition-magic="0:7;1:-1:7:xxxxxxxx-xxxx-xxxx-xxxx-xxxxxxxxxxxx" call-id="1" rc-code="7" op-status="0" interval="0" last-run="1387546150" last-rc-change="1387546150" exec-time="0" queue-time="0" op-digest="f2317cad3d54cec5d7d7aa7d0bf35cf8"/>
+          </lrm_resource>
+          <lrm_resource id="rsc2" class="ocf" provider="pacemaker" type="Dummy">
+            <lrm_rsc_op id="rsc2_last_0" operation_key="rsc2_monitor_0" operation="monitor" crm-debug-origin="crm_simulate" crm_feature_set="3.0.8" transition-key="1:-1:7:xxxxxxxx-xxxx-xxxx-xxxx-xxxxxxxxxxxx" transition-magic="0:7;1:-1:7:xxxxxxxx-xxxx-xxxx-xxxx-xxxxxxxxxxxx" call-id="1" rc-code="7" op-status="0" interval="0" last-run="1387546150" last-rc-change="1387546150" exec-time="0" queue-time="0" op-digest="f2317cad3d54cec5d7d7aa7d0bf35cf8"/>
+          </lrm_resource>
+          <lrm_resource id="rsc3" class="ocf" provider="pacemaker" type="Dummy">
+            <lrm_rsc_op id="rsc3_last_0" operation_key="rsc3_start_0" operation="start" crm-debug-origin="crm_simulate" crm_feature_set="3.0.8" transition-key="2:-1:0:xxxxxxxx-xxxx-xxxx-xxxx-xxxxxxxxxxxx" transition-magic="0:0;2:-1:0:xxxxxxxx-xxxx-xxxx-xxxx-xxxxxxxxxxxx" call-id="2" rc-code="0" op-status="0" interval="0" last-run="1387546150" last-rc-change="1387546150" exec-time="0" queue-time="0" op-digest="f2317cad3d54cec5d7d7aa7d0bf35cf8"/>
+          </lrm_resource>
+          <lrm_resource id="rsc4" class="ocf" provider="pacemaker" type="Dummy">
+            <lrm_rsc_op id="rsc4_last_0" operation_key="rsc4_start_0" operation="start" crm-debug-origin="crm_simulate" crm_feature_set="3.0.8" transition-key="2:-1:0:xxxxxxxx-xxxx-xxxx-xxxx-xxxxxxxxxxxx" transition-magic="0:0;2:-1:0:xxxxxxxx-xxxx-xxxx-xxxx-xxxxxxxxxxxx" call-id="2" rc-code="0" op-status="0" interval="0" last-run="1387546150" last-rc-change="1387546150" exec-time="0" queue-time="0" op-digest="f2317cad3d54cec5d7d7aa7d0bf35cf8"/>
+          </lrm_resource>
+        </lrm_resources>
+      </lrm>
+    </node_state>
+  </status>
+</cib>